% Calculate the separation between 2 sets of n-by-p data matrices with
% separation defined as the distance between the data centers
% Returns -1 if error
function sep=separation(data1,data2)
[n1,p1]=size(data1);
[n2,p2]=size(data2);
if p1 ~= p2  sep=-1; return; end

% find center in each cluster defined as point that minimizes sum of
% distances to all other points
data1_dist=sum(squareform(pdist(data1)));
[C,I_data1]=min(data1_dist);
data2_dist=sum(squareform(pdist(data2)));
[C,I_data2]=min(data2_dist);

sep=sum((data1(I_data1,:)-data2(I_data2,:)).^2).^0.5;