% Script to test sparse SVD decompostion using the C-Lapack version of the code
close all;

% Initialize parameters ****************
n=200;               % Dimension
ratio=100;         % "Signal to noise" ratio
rho=1; % 5         % Penalty factor controlling sparsity (large rho => sparse sol)
maxiter=1000;    % Maximum Number of Iterations
gapchange=0.5e-2;           % Target precision 
info=100;          % Control amount of output
rand('state',25);   % Fix random seed

% Form test matrix as: rank one sparse + noise
testvec=[[1 0 1 0 1 0 1 0 1 0],zeros(1,n-10)];
testvec=testvec/(norm(testvec));
A=rand(n,n);
A=A'*A/n+ratio*testvec'*testvec;

disp('Full Eig');
[U,X,x1] = DSPCA(A,rho,gapchange,maxiter,info,9);
disp('Partial Eig');
[U,X,x3] = DSPCA(A,rho,gapchange,maxiter,info,3);
% Compare with answer from simple eigenvalue decomposition
% [vecsol,diagbuf]=eig(X);
% [veca,diaga]=eig(A);
% diagsol=diag(diagbuf);
% [val,inds]=max(abs(diagsol));
% [val,inda]=max(diag(diaga));
% % Display results...
% disp(' ');
% disp('DSPCA   PCA');
% disp(num2str([vecsol(:,inds),veca(:,inda)],'%8.4f'))
% diagsol;
% disp(' ');
