n=200;
rho=30;
maxiter=1000;    % Maximum Number of Iterations
info=50;       % Frequency of printing information  
gapchange=.01;

raw = dlmread('colondata_mean0std1.csv');
code = raw(1,:);
data = raw(2:2001,:);

keepPCA=n;
% Prune data for keepPCA genes with most variance
datavar=var(data');
sortedvar=sort(datavar,'descend');
var_break=sortedvar(keepPCA);
indkeep=(datavar>=var_break);
% Prune data for keepPCA genes with highest magnitude of factor 3
%     sortedf3=sort(abs(f3_pca),'descend');
%     f3_break=sortedf3(keepPCA);
%     indkeep=(abs(f3_pca)>=f3_break);
experiments=data(indkeep,:);

normal=(code > 0);
tumor=(code < 0);
ind_normal = find(normal);
ind_tumor = find(tumor);
resclass=zeros(1,length(code));
resclass(ind_normal)=1;
cov=experiments*experiments';
[vecs,vals]=eig(cov);
f1=vecs(:,keepPCA);
f2=vecs(:,keepPCA-1);
f3=vecs(:,keepPCA-2);

cov3=cov-(f1'*cov*f1)*f1*f1'; % Warning: might not be psd if too sparse !!!
cov3=(cov3+cov3')/2;
% Test algo: 1 is full eig decomposition, 2 is matrix exponential, 3 for partial
% eig decomposition    
tic;disp(['Dimension = ',num2str(n,'%.4e')]);
% disp('Full Eig');
% [X,U1,u1,F,iters,partialdualitygap,partialcputime,perceigs] = DSPCA(cov3,rho,gapchange,maxiter,info,1);
disp('Partial Eig');
[X,U2,u2,F,iters,partialdualitygap,partialcputime,perceigs] = DSPCA(cov3,rho,gapchange,maxiter,info,3);
disp('Partial Eig Matlab');
[X,U3,u3,F,iters,partialdualitygap,partialcputime,perceigs] = DSPCA(cov3,rho,gapchange,maxiter,info,9);

